---
title: Comparison of CSS Selectors and XPath
slug: Web/XPath/Comparison_with_CSS_selectors
tags:
  - CSS
  - Draft
  - NeedsContent
  - Reference
  - Selectors
  - XPath
---
<p>{{XSLTRef}}{{Page("/en-US/docs/Web/XPath", "Subnav")}}{{Draft}}</p>

<p class="summary">This article seeks to document the difference between CSS Selectors and XPath for web developers to be able to better choose the right tool for the right job.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col"><a href="/en-US/docs/Web/XPath">XPath feature</a></th>
   <th scope="col"><a href="/en-US/docs/Web/CSS/CSS_Selectors">CSS equivalent</a></th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="/en-US/docs/Web/XPath/Axes/ancestor"><code>ancestor</code></a>, <a href="/en-US/docs/Web/XPath/Axes/parent"><code>parent</code></a> or <a href="/en-US/docs/Web/XPath/Axes/preceding-sibling"><code>preceding-sibling</code></a> axis</td>
   <td>{{CSSxRef(":has",":has()")}} selector {{experimental_inline}}</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/XPath/Axes/attribute"><code>attribute</code></a> axis</td>
   <td><a href="/en-US/docs/Web/CSS/Attribute_selectors">Attribute selectors</a></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/XPath/Axes/child"><code>child</code></a> axis</td>
   <td><a href="/en-US/docs/Web/CSS/Child_selectors">Child combinator</a></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/XPath/Axes/descendant"><code>descendant</code></a> axis</td>
   <td><a href="/en-US/docs/Web/CSS/Descendant_selectors">Descendant combinator</a></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/XPath/Axes/following-sibling"><code>following-sibling</code></a> axis</td>
   <td><a href="/en-US/docs/Web/CSS/General_sibling_selectors">General sibling combinator</a> or <a href="/en-US/docs/Web/CSS/Adjacent_sibling_selectors">adjacent sibling combinator</a></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/XPath/Axes/self"><code>self</code></a> axis</td>
   <td>{{CSSxRef(":scope")}} or {{CSSxRef(":host")}} selector</td>
  </tr>
 </tbody>
</table>
